import * as i0 from '@angular/core';
import { Injectable, Component, Input, NgModule } from '@angular/core';
import * as i1 from '@angular/forms';
import { Validators, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { Subject, tap, takeUntil, filter } from 'rxjs';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import { FontAwesomeModule } from '@fortawesome/angular-fontawesome';

class DlsFeedbackService {
    constructor() { }
}
DlsFeedbackService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: DlsFeedbackService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
DlsFeedbackService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: DlsFeedbackService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: DlsFeedbackService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class DlsFeedbackComponent {
    constructor(fb) {
        this.fb = fb;
        this.onClickfeedback$ = new Subject();
        this.rateFeedback$ = new Subject();
        this.onSelectCategory$ = new Subject();
        this.submit$ = new Subject();
        this.selectedCategory = '';
        this.isShowFeedback = false;
        this.categories = ['Improvement', 'Appreciation'];
        this.submitButtonClicked = false;
        this.maximumCharacter = 250;
        this.destroy$ = new Subject();
    }
    ngOnInit() {
        this.initForm();
        this.handleClickFeedback();
        this.handleRateFeedback();
        this.handleSelectCategory();
        this.handleClickSubmit();
    }
    ngOnDestroy() {
        this.destroy$.next();
        this.destroy$.complete();
    }
    get getFeedback() {
        return this.form.get('feedback');
    }
    initForm() {
        this.form = this.fb.group({
            feedback: ['', [Validators.required, Validators.maxLength(this.maximumCharacter)]]
        });
    }
    handleClickFeedback() {
        this.onClickfeedback$
            .pipe(tap(() => {
            this.isShowFeedback = !this.isShowFeedback;
        }), takeUntil(this.destroy$))
            .subscribe();
    }
    handleRateFeedback() {
        this.rateFeedback$
            .pipe(tap((rating) => {
            this.satisfied = rating;
        }), takeUntil(this.destroy$))
            .subscribe();
    }
    handleSelectCategory() {
        this.onSelectCategory$
            .pipe(tap((category) => {
            this.selectedCategory = category;
        }), takeUntil(this.destroy$))
            .subscribe();
    }
    handleClickSubmit() {
        this.submit$
            .pipe(tap(() => this.submitButtonClicked = true), filter(() => this.validateForm()), tap(() => {
            const body = {
                rating: this.satisfied,
                type: this.selectedCategory,
                comment: this.form.value.feedback
            };
            this.resetForm();
            this.isShowFeedback = false;
        }), takeUntil(this.destroy$))
            .subscribe();
    }
    validateForm() {
        if (this.form.invalid || this.satisfied === 0 || this.selectedCategory === '') {
            return false;
        }
        return true;
    }
    resetForm() {
        this.satisfied = 0;
        this.selectedCategory = '';
        this.submitButtonClicked = false;
        this.form.reset();
    }
}
DlsFeedbackComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: DlsFeedbackComponent, deps: [{ token: i1.FormBuilder }], target: i0.ɵɵFactoryTarget.Component });
DlsFeedbackComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.6", type: DlsFeedbackComponent, selector: "dls-feedback", inputs: { displayName: "displayName", title: "title", helpDeskEmail: "helpDeskEmail", helpDeskDepartment: "helpDeskDepartment" }, ngImport: i0, template: "<form [formGroup]=\"form\" class=\"feedback\" [ngClass]=\"isShowFeedback ? '' : 'hide-feedback'\">\r\n    <button class=\"btn-primary feedback-btn\" (click)=\"onClickfeedback$.next()\">\r\n        <span class=\"mdi-set mdi-24px\"></span> Feedback\r\n    </button>\r\n\r\n    <div class=\"feedback-header\">We Want Your Feedback!</div>\r\n    <div class=\"feedback-body\">\r\n        <div class=\"text-center feedback-display-name\">Hi {{ displayName }}!</div>\r\n        <div class=\"text-center mb-2\">{{ title }}</div>\r\n        <div class=\"d-flex justify-content-center align-items-center\">\r\n            <div class=\"bg-rating\" [ngClass]=\"satisfied === 1 ? 'rating-color-red' : 'color-grey'\"\r\n                (click)=\"rateFeedback$.next(1)\">\r\n                <span class=\"fas fa-frown\"></span>\r\n            </div>\r\n            <div class=\"bg-rating\" [ngClass]=\"satisfied === 2 ? 'rating-color-orange' : 'color-grey'\"\r\n                (click)=\"rateFeedback$.next(2)\">\r\n                <span class=\"fas fa-frown-open\"></span>\r\n            </div>\r\n            <div class=\"bg-rating\" [ngClass]=\"satisfied === 3 ? 'rating-color-yellow' : 'color-grey'\"\r\n                (click)=\"rateFeedback$.next(3)\">\r\n                <span class=\"fas fa-meh\"></span>\r\n            </div>\r\n            <div class=\"bg-rating\" [ngClass]=\"satisfied === 4 ? 'rating-color-greenyellow' : 'color-grey'\"\r\n                (click)=\"rateFeedback$.next(4)\">\r\n                <span class=\"fas fa-smile\"></span>\r\n            </div>\r\n            <div class=\"bg-rating\" [ngClass]=\"satisfied === 5 ? 'rating-color-green' : 'color-grey'\"\r\n                (click)=\"rateFeedback$.next(5)\">\r\n                <span class=\"fas fa-smile-beam\"></span>\r\n            </div>\r\n        </div>\r\n        <div class=\"d-flex justify-content-center\">\r\n            <div class=\"satisfied satisfied-color-red\"></div>\r\n            <div class=\"satisfied satisfied-color-orange\"></div>\r\n            <div class=\"satisfied satisfied-color-yellow\" ></div>\r\n            <div class=\"satisfied satisfied-color-greenyellow\"></div>\r\n            <div class=\"satisfied satisfied-color-green\"></div>\r\n        </div>\r\n        <div class=\"err-character\" *ngIf=\"submitButtonClicked && satisfied === null\">\r\n            Happiness Scale cannot be blank\r\n        </div>\r\n        <hr>\r\n        <div>\r\n            <div class=\"text-center mb-2\">Please select your feedback category</div>\r\n            <div class=\"d-flex justify-content-between\">\r\n                <div class=\"d-flex justify-content-center align-items-center category\"\r\n                    *ngFor=\"let category of categories\"\r\n                    (click)=\"onSelectCategory$.next(category)\"\r\n                    [ngClass]=\"selectedCategory === category ? 'selected-category-bg-color' : '.empty-category-bg-color'\"\r\n                >\r\n                    <span>{{ category }}</span>\r\n                </div>\r\n            </div>\r\n            <div class=\"err-character\" *ngIf=\"submitButtonClicked && selectedCategory === null\">\r\n                Feedback Category cannot be blank\r\n            </div>\r\n        </div>\r\n        <hr>\r\n        <div class=\"text-center mb-2\">Please leave your feedback below</div>\r\n        <!-- <app-petronas-dev-textarea \r\n            layout=\"3-9\" \r\n            textarea \r\n            formControlName=\"feedback\" \r\n            label=\"Feedback:\"\r\n            maximumCharacter={{maximumCharacter}}\r\n        >\r\n        </app-petronas-dev-textarea> -->\r\n        <ng-container *ngTemplateOutlet=\"feedBackErr\"></ng-container>\r\n        <div>\r\n            <small>\r\n                <p>For any technical issues, please contact <a href=\"{{ 'mailto:' + helpDeskEmail}}\">\r\n                        {{ helpDeskDepartment }}\r\n                    </a>\r\n                </p>\r\n            </small>\r\n        </div>\r\n    </div>\r\n\r\n    <div class=\"feedback-action\">\r\n        <button class=\"btn btn-primary\" (click)=\"submit$.next()\">\r\n            <span class=\"mdi-set mdi-24px\"></span> Submit\r\n        </button>\r\n    </div>\r\n</form>\r\n\r\n<ng-template #feedBackErr>\r\n    <div class=\"err-character err-feedback-content\" *ngIf=\"getFeedback?.errors && getFeedback?.errors?.maxlength\">\r\n        The Characters submitted has <br/> exceeded more than counter limit {{maximumCharacter}}.\r\n    </div>\r\n</ng-template>", styles: ["@import\"@fortawesome/fontawesome-free/css/all.css\";@import\"feedback/projects/dls-feedback/node_modules/@fortawesome/fontawesome-free/css/all.css\";.bg-rating{font-size:30px;margin-right:.5rem;margin-left:2px}.bg-rating:hover{cursor:pointer}.color-grey{color:#c5c5c5}.rating-color-red{color:#ea344d}.rating-color-orange{color:#ff801e}.rating-color-yellow{color:#ffd12c}.rating-color-greenyellow{color:#97bf17}.rating-color-green{color:#50ce58}.feedback{position:fixed;right:9px;transition:.3s;border:1px solid #00a19c;background-color:#f6f6f6;z-index:100;top:15%}.feedback .feedback-btn{position:absolute;top:45%;left:-19.8%;transform:rotate(90deg);border-radius:0 0 11px 11px;width:78px;height:30px;border:none}.feedback .feedback-btn:focus,.feedback .feedback-btn:hover{background-color:#00a19c;color:#fff;border:none;box-shadow:none}.feedback .feedback-header{padding:15px;background:#00a19c;color:#fff;text-align:center}.feedback .feedback-body{padding:15px}.feedback .feedback-display-name{max-width:248px}.feedback .feedback-action{padding-bottom:15px;text-align:center}.feedback .satisfied{width:40px;height:4px;border:1px solid;margin-left:1px}.feedback .satisfied-color-red{color:#ea344d;background-color:#ea344d}.feedback .satisfied-color-orange{color:#ff801e;background-color:#ff801e}.feedback .satisfied-color-yellow{color:#ffd12c;background-color:#ffd12c}.feedback .satisfied-color-greenyellow{color:#97bf17;background-color:#97bf17}.feedback .satisfied-color-green{color:#50ce58;background-color:#50ce58}.feedback .category{border:1px solid #00a19c;border-radius:5px;padding:.5rem;width:48%;align-items:center;text-align:center}.feedback .category:hover{cursor:pointer}.feedback .empty-category-bg-color{background-color:#f6f6f6}.feedback .selected-category-bg-color{background-color:#00a19c;color:#fff}.hide-feedback{right:-280px}.err-character{padding:0;list-style-type:none;color:red}.err-feedback-content{margin-top:-17px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: DlsFeedbackComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dls-feedback', template: "<form [formGroup]=\"form\" class=\"feedback\" [ngClass]=\"isShowFeedback ? '' : 'hide-feedback'\">\r\n    <button class=\"btn-primary feedback-btn\" (click)=\"onClickfeedback$.next()\">\r\n        <span class=\"mdi-set mdi-24px\"></span> Feedback\r\n    </button>\r\n\r\n    <div class=\"feedback-header\">We Want Your Feedback!</div>\r\n    <div class=\"feedback-body\">\r\n        <div class=\"text-center feedback-display-name\">Hi {{ displayName }}!</div>\r\n        <div class=\"text-center mb-2\">{{ title }}</div>\r\n        <div class=\"d-flex justify-content-center align-items-center\">\r\n            <div class=\"bg-rating\" [ngClass]=\"satisfied === 1 ? 'rating-color-red' : 'color-grey'\"\r\n                (click)=\"rateFeedback$.next(1)\">\r\n                <span class=\"fas fa-frown\"></span>\r\n            </div>\r\n            <div class=\"bg-rating\" [ngClass]=\"satisfied === 2 ? 'rating-color-orange' : 'color-grey'\"\r\n                (click)=\"rateFeedback$.next(2)\">\r\n                <span class=\"fas fa-frown-open\"></span>\r\n            </div>\r\n            <div class=\"bg-rating\" [ngClass]=\"satisfied === 3 ? 'rating-color-yellow' : 'color-grey'\"\r\n                (click)=\"rateFeedback$.next(3)\">\r\n                <span class=\"fas fa-meh\"></span>\r\n            </div>\r\n            <div class=\"bg-rating\" [ngClass]=\"satisfied === 4 ? 'rating-color-greenyellow' : 'color-grey'\"\r\n                (click)=\"rateFeedback$.next(4)\">\r\n                <span class=\"fas fa-smile\"></span>\r\n            </div>\r\n            <div class=\"bg-rating\" [ngClass]=\"satisfied === 5 ? 'rating-color-green' : 'color-grey'\"\r\n                (click)=\"rateFeedback$.next(5)\">\r\n                <span class=\"fas fa-smile-beam\"></span>\r\n            </div>\r\n        </div>\r\n        <div class=\"d-flex justify-content-center\">\r\n            <div class=\"satisfied satisfied-color-red\"></div>\r\n            <div class=\"satisfied satisfied-color-orange\"></div>\r\n            <div class=\"satisfied satisfied-color-yellow\" ></div>\r\n            <div class=\"satisfied satisfied-color-greenyellow\"></div>\r\n            <div class=\"satisfied satisfied-color-green\"></div>\r\n        </div>\r\n        <div class=\"err-character\" *ngIf=\"submitButtonClicked && satisfied === null\">\r\n            Happiness Scale cannot be blank\r\n        </div>\r\n        <hr>\r\n        <div>\r\n            <div class=\"text-center mb-2\">Please select your feedback category</div>\r\n            <div class=\"d-flex justify-content-between\">\r\n                <div class=\"d-flex justify-content-center align-items-center category\"\r\n                    *ngFor=\"let category of categories\"\r\n                    (click)=\"onSelectCategory$.next(category)\"\r\n                    [ngClass]=\"selectedCategory === category ? 'selected-category-bg-color' : '.empty-category-bg-color'\"\r\n                >\r\n                    <span>{{ category }}</span>\r\n                </div>\r\n            </div>\r\n            <div class=\"err-character\" *ngIf=\"submitButtonClicked && selectedCategory === null\">\r\n                Feedback Category cannot be blank\r\n            </div>\r\n        </div>\r\n        <hr>\r\n        <div class=\"text-center mb-2\">Please leave your feedback below</div>\r\n        <!-- <app-petronas-dev-textarea \r\n            layout=\"3-9\" \r\n            textarea \r\n            formControlName=\"feedback\" \r\n            label=\"Feedback:\"\r\n            maximumCharacter={{maximumCharacter}}\r\n        >\r\n        </app-petronas-dev-textarea> -->\r\n        <ng-container *ngTemplateOutlet=\"feedBackErr\"></ng-container>\r\n        <div>\r\n            <small>\r\n                <p>For any technical issues, please contact <a href=\"{{ 'mailto:' + helpDeskEmail}}\">\r\n                        {{ helpDeskDepartment }}\r\n                    </a>\r\n                </p>\r\n            </small>\r\n        </div>\r\n    </div>\r\n\r\n    <div class=\"feedback-action\">\r\n        <button class=\"btn btn-primary\" (click)=\"submit$.next()\">\r\n            <span class=\"mdi-set mdi-24px\"></span> Submit\r\n        </button>\r\n    </div>\r\n</form>\r\n\r\n<ng-template #feedBackErr>\r\n    <div class=\"err-character err-feedback-content\" *ngIf=\"getFeedback?.errors && getFeedback?.errors?.maxlength\">\r\n        The Characters submitted has <br/> exceeded more than counter limit {{maximumCharacter}}.\r\n    </div>\r\n</ng-template>", styles: ["@import\"@fortawesome/fontawesome-free/css/all.css\";@import\"feedback/projects/dls-feedback/node_modules/@fortawesome/fontawesome-free/css/all.css\";.bg-rating{font-size:30px;margin-right:.5rem;margin-left:2px}.bg-rating:hover{cursor:pointer}.color-grey{color:#c5c5c5}.rating-color-red{color:#ea344d}.rating-color-orange{color:#ff801e}.rating-color-yellow{color:#ffd12c}.rating-color-greenyellow{color:#97bf17}.rating-color-green{color:#50ce58}.feedback{position:fixed;right:9px;transition:.3s;border:1px solid #00a19c;background-color:#f6f6f6;z-index:100;top:15%}.feedback .feedback-btn{position:absolute;top:45%;left:-19.8%;transform:rotate(90deg);border-radius:0 0 11px 11px;width:78px;height:30px;border:none}.feedback .feedback-btn:focus,.feedback .feedback-btn:hover{background-color:#00a19c;color:#fff;border:none;box-shadow:none}.feedback .feedback-header{padding:15px;background:#00a19c;color:#fff;text-align:center}.feedback .feedback-body{padding:15px}.feedback .feedback-display-name{max-width:248px}.feedback .feedback-action{padding-bottom:15px;text-align:center}.feedback .satisfied{width:40px;height:4px;border:1px solid;margin-left:1px}.feedback .satisfied-color-red{color:#ea344d;background-color:#ea344d}.feedback .satisfied-color-orange{color:#ff801e;background-color:#ff801e}.feedback .satisfied-color-yellow{color:#ffd12c;background-color:#ffd12c}.feedback .satisfied-color-greenyellow{color:#97bf17;background-color:#97bf17}.feedback .satisfied-color-green{color:#50ce58;background-color:#50ce58}.feedback .category{border:1px solid #00a19c;border-radius:5px;padding:.5rem;width:48%;align-items:center;text-align:center}.feedback .category:hover{cursor:pointer}.feedback .empty-category-bg-color{background-color:#f6f6f6}.feedback .selected-category-bg-color{background-color:#00a19c;color:#fff}.hide-feedback{right:-280px}.err-character{padding:0;list-style-type:none;color:red}.err-feedback-content{margin-top:-17px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.FormBuilder }]; }, propDecorators: { displayName: [{
                type: Input
            }], title: [{
                type: Input
            }], helpDeskEmail: [{
                type: Input
            }], helpDeskDepartment: [{
                type: Input
            }] } });

class DlsFeedbackModule {
}
DlsFeedbackModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: DlsFeedbackModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DlsFeedbackModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.6", ngImport: i0, type: DlsFeedbackModule, declarations: [DlsFeedbackComponent], imports: [CommonModule,
        FormsModule,
        ReactiveFormsModule,
        FontAwesomeModule], exports: [DlsFeedbackComponent] });
DlsFeedbackModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: DlsFeedbackModule, imports: [CommonModule,
        FormsModule,
        ReactiveFormsModule,
        FontAwesomeModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: DlsFeedbackModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DlsFeedbackComponent,
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule,
                        FontAwesomeModule
                    ],
                    exports: [
                        DlsFeedbackComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of dls-feedback
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DlsFeedbackComponent, DlsFeedbackModule, DlsFeedbackService };
//# sourceMappingURL=dls-feedback.mjs.map
